package com.agiledeveloper

import grails.test.mixin.TestFor
import spock.lang.Specification

/**
 * See the API for {@link grails.test.mixin.domain.DomainClassUnitTestMixin} for usage instructions
 */
@TestFor(Person)
class PersonSpec extends Specification {
  def johnDoe
  
  def setup() {
    johnDoe = new Person(
      firstName: 'John', lastName: 'Doe', emailAddress: 'jd@example.com')
      
    mockForConstraintsTests Person, [johnDoe]
  }
  
  def cleanup() {
  }
  
  void "test create person"() {
    expect:
      johnDoe.validate()
  }
  
  void "test first name required"() {
    johnDoe.firstName = ''
    expect:
      false == johnDoe.validate()
      '' == johnDoe.errors.getFieldError('firstName').rejectedValue
  }

  void "test last name required"() {
    johnDoe.lastName = ''
    expect:
      false == johnDoe.validate()
      '' == johnDoe.errors.getFieldError('lastName').rejectedValue
  }
  
  void "test email address must be valid"() {
    johnDoe.emailAddress = 'jd'
    expect:
      false == johnDoe.validate()
      johnDoe.emailAddress == johnDoe.errors.getFieldError('emailAddress').rejectedValue
  }
  
  void "test email address is unique"() {
    def person2 = new Person(
      firstName: 'Jane', lastName: johnDoe.lastName, emailAddress: johnDoe.emailAddress)
    
    expect:
      false == person2.validate()
      person2.emailAddress ==
        person2.errors.getFieldError('emailAddress').rejectedValue
  }
}
